{-# OPTIONS --safe --without-K #-}

module Categories.Category.Instance.Thinnings where

open import Categories.Category.Core
open import Categories.Category.Helper
open import Categories.Object.Initial
open import Data.List.Base using (List; [])
open import Level using (Level)
open import Relation.Binary.PropositionalEquality

open import Thinning
open import Thinning.Properties

private
  variable
    a : Level
    A : Set a

Thinnings : ∀ {a} (A : Set a) → Category a a a
Thinnings A = categoryHelper record
  { Obj = List A
  ; _⇒_ = Thinning A
  ; _≈_ = _≡_
  ; id = id
  ; _∘_ = _∘_
  ; assoc = assoc _ _ _
  ; identityˡ = identityˡ _
  ; identityʳ = identityʳ _
  ; equiv = isEquivalence
  ; ∘-resp-≈ = cong₂ _∘_
  }

[]-isInitial : IsInitial (Thinnings A) []
[]-isInitial = record { !-unique = ¡-unique }

initial : Initial (Thinnings A)
initial = record { ⊥-is-initial = []-isInitial }
